<?php
/**
  @version 1.0
  @copyright Key2Publish
  @author Jordy Nieland
 */

error_reporting(-1);
ini_set('display_errors', 'On');

//Get Functions
include('Functions.php');

//Init params
$MAGENTO = './app/Mage.php';						//Magento class location
$IMGLOCATION = './media/catalog/';			//Magento image location
$SQLOCATION = $_SERVER["DOCUMENT_ROOT"] . '/../tmp/';//Location to put sqlite files
$SQNAME = 'key2_db';								//Sqlite database name
$STEPS = 25;										//Amount of steps per post
$db = connectSqlite($SQLOCATION, $SQNAME);			//Connect sqlite
$MAX_EXECUTION_TIME = 600;							//The maximum execution time of script

//WARNING: THESE VARIABLES MUST BE SET WELL BEFORE DATA IS IN MAGENTO!
$child_sku_hash = false;			//Set hash in string or false for off
$parent_sku_hash = '_parent';		//Set hash in string or false for off NOTE: This only works for configurable products!

//Sets the maximum excecution time
set_time_limit ($MAX_EXECUTION_TIME);	//max 1 hour execution time

/*
 * If there is a action, do following
 */
//echo $SQLOCATION;
if(isset($_POST['command'])){

	//INIT params
	if(isset($_POST['params']['store_ids'])){
		$STORE = $_POST['params']['store_ids'];
	}
	if(isset($_POST['params']['lang_id'])){
		$LANG = $_POST['params']['lang_id'];
	}

	if(isset($_POST['params']['inclVAT'])){
		$VAT = $_POST['params']['inclVAT'];
	}

	if(isset($_POST['username'])){
		$username = $_POST['username'];
	}

	if(isset($_POST['password'])){
		$password = $_POST['password'];
	}



	/*
	 * @param $MAGENTO, $username, $password
	 *
	 * Try to login with loginAdmin() function
	 */
	$login = loginAdmin($MAGENTO, $username, $password);
	if($login){
		switch($_POST['command']){
			/*
			 * Check wich action to perform based on $_POST['command']
			 */
			case 'doLogin':
				if(json_decode($_POST['params'])->type){
					if(json_decode($_POST['params'])->type == "groups"){
						$IMGLOCATION = $IMGLOCATION . "/category";
						uploadFile($_FILES['file'], $IMGLOCATION, $_FILES['file']['name'], '');
					} else{
						$IMGLOCATION = $IMGLOCATION . "/product";

						//Create directories
						$first_letter = $_FILES['file']['name'][0];
						$second_letter = $_FILES['file']['name'][1];
						$IMGLOCATION_first = $IMGLOCATION."/".$first_letter;
						$IMGLOCATION_complete = $IMGLOCATION."/".$first_letter."/".$second_letter;

						if (!file_exists($IMGLOCATION)) {
							mkdir($IMGLOCATION);
						}
						if (!file_exists($IMGLOCATION_first)) {
							mkdir($IMGLOCATION_first);
						}
						if (!file_exists($IMGLOCATION_complete)) {
							mkdir($IMGLOCATION_complete);
						}

						uploadFile($_FILES['file'], $IMGLOCATION_complete, $_FILES['file']['name'], '');
						//echo $_FILES['file']['name'] . " has been uploaded succesfully.";
					}


					echo "yes";
				} else{
					echo uploadFile($_FILES['file'], $SQLOCATION, $SQNAME, '.sqlite');
					//echo "SQLite upload succesful!";
				}

				break;

			case 'insertCategories':

					$START = json_decode($_POST['params'])->start;
					$categories = getCategoriesSqlite($db, $START, $STEPS);
					$parents = getCategoriesSqlite($db, null, null);
					$STEPS = count($categories);
					exportCategories($categories, $parents, $MAGENTO, $START, $STEPS, getCategorieTree($db), getCategoryStringPath($db, getCategoriesSqlite($db)));
				break;

			case 'deleteCategories':
					$START = json_decode($_POST['params'])->start;
					$categories = getCategoriesSqlite($db, $START, $STEPS);
					deleteCategories($MAGENTO, $categories, $START, $STEPS, getCategoryStringPath($db, getCategoriesSqlite($db)));
				break;

			case 'insertProducts':
					$START = json_decode($_POST['params'])->start;
					$VAT = json_decode($_POST['params'])->inclVAT;
					$categories = getCategoriesSqlite($db);
					$parents = getParentsSqlite($db);
					$datatypes = getAllAttributeOptions($db);
					$simpleattributes = getSimpleAttributes($db);
					$c_products = getProductsSqlite($db, getDatatype($db), $START, $STEPS);
					$STEPS = count($c_products);
					$TOTALPRODUCTS = countProductsSqlite($db);
					if(getDatatype($db) == 'simple'){
						$children = array();
					} else{
						$children = getChildrenBySuperIndex($db);
					}

					exportProducts($c_products, $categories, $parents, $MAGENTO, $STEPS, $START, $datatypes, $children, getAttributes($db), $VAT, $child_sku_hash, $parent_sku_hash, $IMGLOCATION, $TOTALPRODUCTS, getCategoryStringPath($db, getCategoriesSqlite($db)), $simpleattributes);
				break;
			case 'deleteProducts':
					$START = json_decode($_POST['params'])->start;
					$type = getDatatype($db);

					if(getDatatype($db) == 'simple'){
						$children = array();
					} else{
						$children = getChildrenBySuperIndex($db);
					}

					$products = getProductsSqlite($db, $type, $START, $STEPS);
					$STEPS = count($products);
					deleteProducts($MAGENTO, $products, $STEPS, $START, $children, $child_sku_hash, $parent_sku_hash);
				break;
			case 'getStores':
				getStores();
				break;
			case 'getLanguages':
				getLanguages();
				break;
			case 'insertOptions':
				exportOptions(getOptionSqlite($db));
				break;
			case 'deleteOptions':
				deleteOptions(getOptionSqlite($db));
				break;
			case 'insertManufacturer':
				exportManufacturers(getManufacturers($db));	//Create attribute(s)
				break;
			case 'deleteManufacturer':
				deleteManufacturer(getManufacturers($db));
				break;
			case 'insertAttributes':
				$attributes = getAttributes($db);
				exportOptions($attributes, 'attribute');
				break;
		}
	}
}
?>
