<?

/*
 * Copyright Key2Publish BV 2015-2016
 * Exports Products (simple only) and Categories from Magento into the Key2Publish Application
 * 23-11-2015
 * Marnix Blaauw
 * */

//Include de mage.php.
require_once 'app/Mage.php';

//Initaliseer de mage app.
Mage::init();

$command = cleanPost($_POST['command']);
$speed = cleanPost($_POST['speed']);
$page = cleanPost($_POST['page']);
$gebruiker = cleanPost($_POST['usr']);
$wachtwoord = cleanPost($_POST['pwd']);

if ($gebruiker === '' || $wachtwoord === '' || $command === '') {
	echo "I don't have all required POST variables";
}
//$_POST['cdatatypes'] = "name";

$productDataTypes = ((isset($_POST['pdatatypes'])) ? explode(',',cleanPost($_POST['pdatatypes'])) : '');
$catalogDataTypes = ((isset($_POST['cdatatypes'])) ? explode(',',cleanPost($_POST['cdatatypes'])) : '');

if ((!is_numeric($page) && $page !== '') || (!is_numeric($speed) && $speed !== '')) {
	echo ('Input not allowed');
	die;
}

if ((!is_array($productDataTypes) && $productDataTypes !== '') || (!is_array($catalogDataTypes) && $catalogDataTypes !== '')) {
	echo ("I don't have the correct input");
	die;
}

function cleanPost($post) {
	$post = mb_convert_encoding($post, 'UTF-8', 'UTF-8');
	$post = htmlentities($post, ENT_QUOTES, 'UTF-8');
	return $post;
}

function login($gebruiker, $wachtwoord)
{
    //Initialiseer een back-end session.
    Mage::getSingleton('core/session', array('name' => 'adminhtml'));

    //Maakt instantie van de admin/user class.
    $gebruikerModel = Mage::getModel('admin/user');

    //Kijkt of er een geldige authenticatie gestart kan worden met de gegeven gebruikersnaam en wachtwoord.
    if($gebruikerModel->authenticate($gebruiker, $wachtwoord)){
        //Als authencatie succesvol is return true
        return true;
    }
    else {
        echo('Error: Login niet gelukt.');
		die;
    }
}

function getProductCount() {
	   $productcount = 0;
	   $_catCollection = Mage::getModel('catalog/category')
        ->getCollection()
        ->addAttributeToSelect('*')
		->addAttributeToFilter('is_active','1');
       foreach ($_catCollection as $_category) {
			$cat = array();	
			$cat["children"] = $_category->getChildren();
			if ($cat["children"] === '') {
				$productcount += $_category->getProductCount();
			}
		}
    echo $productcount;
}

function getCategoryCount() {
    $collection = Mage::getResourceModel('catalog/category_collection');
    echo ($collection->getSize());
}

function getCategory($speed, $page, $dataTypes)
{
    //Variabele voor het aantal data types.
    $teller = count($dataTypes);
    $cats=array();
    $currentPage = 1;
    $_catCollection = Mage::getModel('catalog/category')
        ->getCollection()
        ->addAttributeToSelect('*')
		->addAttributeToFilter('is_active','1');
    $_catCollection->setPageSize($speed);
        $_catCollection->setCurPage($page);
        $_catCollection->load();

        foreach ($_catCollection as $_category) {
			$cat = array();			
            for ($i = 0; $i < $teller; $i++) {
				switch($dataTypes[$i]) {
					case "index":
						$cat["data"][$dataTypes[$i]] = $_category->getData("entity_id");
					break;
					case "picture":	
						$img = $_category->getData($dataTypes[$i]);
						if (isset($img) && ($img !== '')) {
							$url = 'http'.(isset($_SERVER['HTTPS'])?'s':'').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
							$server = pathinfo($url);
							$cat["data"][$dataTypes[$i]] = $server["dirname"] . "/media/catalog/category" . $img;
						} else {
							$cat["data"][$dataTypes[$i]] = '';
						}
					break;					
					default:
						$cat["data"][$dataTypes[$i]] = $_category->getData($dataTypes[$i]);	
					
				}
                
            }
			$cat["parent"] = $_category->getParentId();
            $cat["parentCat"] = $_category->getPathIds();
			$cat["children"] = $_category->getChildren();
			if ($cat["children"] === '') {
				$prodCol = $_category->getProductCollection()->addAttributeToSelect('*')->addAttributeToFilter('type_id', array('eq' => 'simple'));
				foreach ($prodCol as $_product) {
					if (isset($cat["myproducts"]) && $cat["myproducts"] !== '') { $cat["myproducts"] .= ","; }
					$cat["myproducts"] .= $_product->getId();
				}
			}
				//$cat["products"] = $_category->getProductCollection()->addAttributeToSelect('*')->addAttributeToFilter('type_id', array('eq' => 'simple'))->getSkus; }
			$cat["level"] = $_category->getData('level');
            $cats[$cat["data"]["index"]] = $cat;
			flush($cat);
        }
        $_catCollection->clear();
        echo json_encode($cats, JSON_FORCE_OBJECT | JSON_UNESCAPED_SLASHES);

}

function getProducts($speed, $page, $dataTypes)
{	
    $prods = array();
	$teller = count($dataTypes);
    $_productCollection = Mage::getModel('catalog/product')
        ->getCollection()
        ->addAttributeToSelect('*')
		->addAttributeToFilter('type_id', array('eq' => 'simple'));
    $_productCollection->setPageSize($speed);
    $_productCollection->setCurPage($page);
    $_productCollection->load();
        foreach ($_productCollection as $_product){
		    $prod = array();
            for ($i = 0; $i < $teller; $i++) {
				// replace spaces too magento underscore
				$dataType[$i] = preg_replace('/\s+/','_', $dataTypes[$i]);
				switch($dataTypes[$i]) {
					case "productid":
						//get SKU
						$prod["data"][$dataTypes[$i]] = $_product->getSku();
						break;
					case "name":
						$prod["data"][$dataTypes[$i]] = $_product->getName();						
						break;
					case "description":
						$desc = (($_product->getData("description") != '') ? $_product->getData("description") : $_product->getData('short_description'));
						$prod["data"][$dataTypes[$i]] = $desc;
						break;
					case "picture":
						$img = (($_product->getData("small_image") != '') ? $_product->getData("small_image") : $_product->getData("thumbnail"));
						if (isset($img) && ($img !== '')) {
						//$img = preg_replace('/[^A-Za-z0-9 _ .-]/', '', $img);
							$url = 'http'.(isset($_SERVER['HTTPS'])?'s':'').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
							$server = pathinfo($url);
						
							$img = $server["dirname"] . "/media/catalog/product" . $img;	
							$prod["data"][$dataTypes[$i]] = $img;
						} else {
							$prod["data"][$dataTypes[$i]] = '';							
						}
						//print_r($img);
						break;
					case "price":
						$price = $_product->getData("price");
						$price = number_format ($price , 2, ",", "");
						$prod["data"][$dataTypes[$i]] = $price;
						break;
					case "vat":
						$store = Mage::app()->getStore();
						$taxCalculation = Mage::getModel('tax/calculation');
						$request = $taxCalculation->getRateRequest(null, null, null, $store);
						$taxClassId = $_product->getTaxClassId();
						$percent = $taxCalculation->getRate($request->setProductClassId($taxClassId));
						$prod["data"][$dataTypes[$i]] = $percent . "%";
						break;
					default:
						$prod["data"][$dataTypes[$i]] = $_product->getData($dataType[$i]);
				}
            }
			$prod["parent"] = $_product->getCategoryIds();
			
            $prods[$_product->getId()] = $prod;
            flush($prod);
        }
        $_productCollection->clear();
        echo json_encode($prods, JSON_FORCE_OBJECT | JSON_UNESCAPED_SLASHES);
}


if (login($gebruiker,$wachtwoord)) {
	switch($command){
		case "getCategoryCount":
			getCategoryCount();
			break;
		case "getProductCount";
			getProductCount();
			break;
		case "getCategory":
			getCategory($speed, $page, $catalogDataTypes);
			break;
		case "getProducts":
			getProducts($speed, $page, $productDataTypes);
			break;
		default:
			echo "Invalid command!";
		break;
	}
}

// end of file
?>